// file      : xsd-frontend/parser.hxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005-2007 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#ifndef XSD_FRONTEND_PARSER_HXX
#define XSD_FRONTEND_PARSER_HXX

#include <cult/types.hxx>

#include <xsd-frontend/semantic-graph/schema.hxx>

namespace XSDFrontend
{
  using namespace Cult::Types;

  struct InvalidSchema {};

  class Parser: public NonCopyable
  {
  public:
    ~Parser ();

    Parser (Boolean proper_restriction);

  public:
    // Throws InvalidSchema in case of a failure.
    //
    Evptr<SemanticGraph::Schema>
    parse (SemanticGraph::Path const&);

    // Returns a schema graph that corresponds to the XML Schema
    // namespace with built-in type definitions. The path is fake
    // and is only used as a lable.
    //
    Evptr<SemanticGraph::Schema>
    xml_schema (SemanticGraph::Path const&);

  private:
    class Impl;
    Evptr<Impl> impl_;
  };
}

#endif  // XSD_FRONTEND_PARSER_HXX
